' Maxtek DCM-220.bas for FilmStar DESIGN 32-bit
' Copyright 1999 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program modifies Maxtek DCM-220 Process Info (*.prc) files

' ------------------------------ NOTES ------------------------------

' 1. Layer Mode designs must be in physical thickness (nm, m or k)

' 2. The 'Description' column of the Film Indices editor must contain
'    valid Material Names from the Edit Material list in DCM-220 software

' 3. Adjust the following line for your computer
     Const MaxtekPath$ = "c:\Maxtek"
' -------------------------------------------------------------------

Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Option Explicit
DefLng i-N

Sub Main
    Dim k, kFilm, nlayer, p As String *256, tLayer!, xdum!, fOpen$, fSave$
    Dim pProc$, nProc$, pFilm$, Matls$, Layer$, mLayer$, rev$, d$, s$, uLayer$, films$

    ' Get Maxtek data paths
    k = GetPrivateProfileString("RunConfig","ProcessPath", "", p$, 255, MaxtekPath & "\mdc360.ini")
    pProc$ = Left(p$, k)
    k = GetPrivateProfileString("RunConfig","MaterialPath", "", p$, 255, MaxtekPath & "\mdc360.ini")
    pFilm$ = Left(p$, k)
    
    ' Get list of valid material names
    s$ = Dir(pFilm$ & "\*.flm")
    k = GetPrivateProfileString("Parameters","01 Name", "", p$, 255, pFilm$ & "\" & s$)
    Matls$ = Left(p$, k) & "|"
    Do
        s$ = Dir
        k = GetPrivateProfileString("Parameters","01 Name", "", p$, 255, pFilm$ & "\" & s$)
        Matls$ = Matls$ & Left(p$, k) & "|"
    Loop Until s$= ""
    Matls$ = LCase(Matls$)
    
    ' Get file names from user
    fOpen$ = GetFilePath(,"prc", pProc$, "Open Process File to use as template", 0)
    If Len(fOpen$) = 0 Then End     ' no file selected
    fSave$ = GetFilePath(,"prc", pProc$, "Save new Process File as", 3)
    If Len(fSave$) = 0 Then End     ' no file selected
    If LCase(fOpen$) <> LCase(fSave$) Then FileCopy fOpen, fSave
    
    ' Suggest process name from file name
    FilePath fSave$, d$, s$
    Do
        nProc$ = InputBox("Process Name? (10 char max)", "Enter Name", Left$(s$, Len(s$)-4))
        If Len(nProc$)>0 Then Exit Do
        MsgBox "Cannot have blank process name", vbExclamation, "Error"
    Loop
    If Len(nProc$)>10 Then nProc$ = Left(nProc, 10)
    k = WritePrivateProfileString("ProcessInfo", "ProcessName", nProc$, fSave$)

    ' Clear existing Materials and ProcessFilmSequence
    WritePrivateProfileSection "Materials", "", fSave
    WritePrivateProfileSection "ProcessFilmSequence", "", fSave
    
    ' Create new Materials and ProcessFilmSequence
    rev$ = Review(3)    ' Review Design string in format 3
    Do
        Parse rev$, s$, xdum, vbCrLf
    Loop Until Left(s$, 3) = "SUB"
    Parse rev$, s$, xdum, vbCrLf    ' Read next line
    
    ' Read layer lines from review
    Do
        Parse rev$, Layer$, xdum, vbCrLf
        If Trim$(Layer$) = "" Then Exit Do
        Parse Layer$, s$, nlayer, " "       ' Number
        Parse Layer$, s$, tLayer, " "       ' Thickness
        Parse Layer$, uLayer$, xdum, " "    ' Unit
        Select Case uLayer  ' convert to k
        Case "nm"
            tLayer = .01 * tLayer
        Case "k"
            'tLayer = tLayer
        Case "m"
            tLayer = 10 * tLayer
        Case Else
            MsgBox "Layers must be in physical thickess nm, m or k",  vbCritical, "Program Halt"
            End     ' quit
        End Select
        Parse Layer$, mLayer$, xdum, " "    ' Material
        If mLayer$="" Or InStr(Matls$, LCase(mLayer$) & "|") = 0 Then
            MsgBox "Design contains undefined film material" & vbCrLf & "in Film Indices Description column", vbCritical, "Program Halt"
            End     ' quit
        End If

' -------------------------------------------------------------------
        ' Advanced users can adjust theoretical values here

'       Select Case LCase(mLayer$)
'        Case "tio2"
'            tLayer = tLayer * 1.05 ' modify thickness here
'        Case "sio2"
'            tLayer = tLayer * .95  ' modify thickness here
'        End Select
' -------------------------------------------------------------------

    If InStr(films$, mLayer$ & "|") = 0 Then
            kFilm = kFilm + 1
            films$ = films$ & mLayer$ & "|"
            k = WritePrivateProfileString("Materials", Format$(kFilm,"000"), mLayer$, fSave$)
        End If
        k = WritePrivateProfileString("ProcessFilmSequence", Format$(nlayer,"000"), mLayer$ & "," & Format$(tLayer,"0.000"), fSave$)
    Loop
End Sub

Sub Parse(strin$, strout$, xout As Variant, delim$)
    On Error Resume Next
    Dim i
    strin$ = Trim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout) ' Decimal "."
End Sub

Sub FilePath(ByVal f$, path$, fName$)
    Dim k, r$
    k = InStr(f$, "\")
    If k = 0 Then
        k = InStr(f$, ":")
        If k = 0 Then
            path$ = ""
            fName$ = f$
        Else
            path$ = Mid(f$, 1, 2)
            fName$ = Mid$(f$, 3)
        End If
    Else
        r$ = szReverse(f$)
        k = Len(f$) - InStr(r$, "\") + 1
        path$ = Mid$(f$, 1, k - 1)
        fName$ = Mid$(f$, k + 1)
    End If
End Sub

Function szReverse$(ByVal s$)
    Dim i, klen, a$
    klen = Len(s$)
    For i = 1 To klen
        a$ = a$ & Mid$(s$, klen - i + 1, 1)
    Next i
    szReverse$ = a$
End Function

