'#Reference {101F9C56-A0F3-455C-ABBB-191168ABCF94}#1.0#0#C:\Program Files\Chilkat Software Inc\Chilkat XML\ChilkatXml.dll#Chilkat XML 5.0.0
' Program SproImportNK.bas for FilmStar INDEX
'         Copyright FTG Software 2005
' Imports indices from SYRUSpro XML files (.ldd)
'
' *********************************************
'   Uses ChilkatXML www.chilkatsoft.com (free)
'    Direct link to ChilkatXML installer:
'  www.chilkatsoft.com/download/XmlActiveX.msi
'
'    XML Schema LeyboldMonitoringReport.xsd
' *****************************************************
'                 REVISION 1.00
'         MAKE SURE THIS PATH EXISTS
Const SproPath$ = "c:\Winfilm\Course2\Monitor\SYRUSpro"
' *****************************************************

Option Explicit
DefLng i-n
DefSng A-H, O-Z
Option Base 1

Sub Main
    Dim f$
    f$ = GetFilePath$(,"ldd", SproPath$, "Open SYRUSPro dispersion file", 0)  ' Save file
    If f$ = "" Then
        End     ' no file loaded
    Else
        ParseXML f$
    End If
End Sub

Sub ParseXML(ByVal file$)
    Dim xml As New ChilkatXml
    Dim xml1 As New ChilkatXml
    Dim xml2 As New ChilkatXml
    Dim i, j, nTable, kTable, nCoeff, kCoeff, fName$

    xml.LoadXmlFile file$

    For j = 1 To xml.NumAttributes
        Select Case xml.GetAttributeName(j - 1)
        Case "name"         ' file name
            fName$ = xml.GetAttributeValue(j - 1)
            FileOpen fName$ ' open current index file
        Case Else
        End Select
    Next j

    For i = 1 To xml.NumChildren
        Set xml1 = xml.GetChild(i - 1)
        Select Case xml1.Tag
        Case "range"
            Dim Range(2) As Single
            Range(1) = Val(xml1.GetAttributeValue(0))
            Range(2) = Val(xml1.GetAttributeValue(1))
           Set FunctionRange = Range
        Case "complex_refractive_index_table"
            nTable = CLng(xml1.NumChildren)
            ReDim xnk(nTable, 3)
            For j = 1 To nTable
                Set xml2 = xml1.GetChild(j - 1)
                xnk(j, 1) = Val(xml2.GetAttributeValue(0))
                xnk(j, 2) = Val(xml2.GetAttributeValue(1))
                xnk(j, 3) = Val(xml2.GetAttributeValue(2))
            Next j
            Set nkTable = xnk

        Case "refractive_index"
            Select Case xml1.GetAttributeValue(0)
            Case "Table"
                nTable = CLng(xml1.NumChildren)
                ReDim xnk(nTable, 3)
                For j = 1 To nTable
                    Set xml2 = xml1.GetChild(j - 1)
                    xnk(j, 1) = Val(xml2.GetAttributeValue(0))
                    xnk(j, 2) = Val(xml2.GetAttributeValue(1))
                    xnk(j, 3) = 0
                Next j
                Set nkTable = xnk
            Case "Sellmeier1", "Sellmeier2", "Sellmeier2TickMark", "Sellmeier3", "Hartmann1", "Hartmann2", "Cauchy"
                Set xml2 = xml1.GetChild(0)
                nCoeff = xml2.NumAttributes
                ReDim coeff(nCoeff)
                For j = 1 To xml2.NumAttributes
                    coeff(j) = Val(xml2.GetAttributeValue(j - 1))
                Next j
            End Select

        Case "extinction_coefficient"
            Select Case xml1.GetAttributeValue(0)
            Case "Sellmeier", "Exponential"
                Set xml2 = xml1.GetChild(0)
                kCoeff = xml2.NumAttributes
                ReDim Preserve coeff(nCoeff + kCoeff)
                For j = 1 To xml2.NumAttributes
                    coeff(j + nCoeff) = Val(xml2.GetAttributeValue(j - 1))
                Next j
            Case "Zero"
                ' do nothing
            Case "Table"
                kTable = CLng(xml1.NumChildren)
                ReDim xnk(kTable, 3)
                For j = 1 To nTable
                    Set xml2 = xml1.GetChild(j - 1)
                    xnk(j, 1) = Val(xml2.GetAttributeValue(0))
                    xnk(j, 2) = 0
                    xnk(j, 3) = Val(xml2.GetAttributeValue(1))
                Next j
                Set nkTable = xnk
            End Select
        Case Else
            MsgBox "Invalid tag", vbCritical, "Leybold Dispersion"
            End
        End Select
        If nCoeff + kCoeff > 0 Then Set FunctionCoeff = coeff
    Next i
    FunctionRange = Range
End Sub


