' ThickListCF.bas for FilmStar DESIGN
' Copyright 1995-2007 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program creates a list of physical thicknesses for crystal controllers
' The design remains in optical thickness
' It gets the material name from the Description column in Film Indices
' Based on ThickList.bas, adds Compensation Function
'
Option Explicit
DefInt i-n
DefSng a-h, o-z
Option Base 1

Sub Main
    Dim i, Layers, q(), qTyp$(), qDesc$(), d$, qTotL, qTotH, v
    DesignConvert 1, "N"            ' convert to nm
    GetLayers Layers, q(), qTyp$(), qDesc$()   ' get design
    For i = 1 To Layers

        Select Case qTyp$(i)
        Case "L"
            v = q(i) * CF_L(q(i))
        Case "H"
            qTotH = qTotH + .5 * q(i)
            v = q(i) * CF_H(qTotH)
        End Select

        d$ = d$ & Format$(i, "000") & PadString$(Format$(v, "0.00"), 9, 0) & " nm     " _
             & Format$(.01 * v, "0.000") & " k  " & qDesc$(i)

        Select Case qTyp$(i)
		Case "L"
            d$ = d$ & "  SiO2" & vbCrLf
        Case "H"
            d$ = d$ & "  TiO2" & vbCrLf
        End Select
    Next i
    Display d$, "Crystal Monitor Settings", 7000, 4500, "Courier New", 10, 0
    DesignConvert 2		' convert to optical according to settings
End Sub

Function CF_L(ByVal qLay As Single) As Single ' qLay is Layer Thickness (nm)
    'SiO2
    CF_L = 1.00170 - 1.3390E-4 * qLay
End Function

Function CF_H(ByVal qTot As Single) As Single ' qTot is Total Thickness (nm)
    'TiO2
    CF_H = 0.99852 - 4.6743E-6 * qTot + 6.5059E-8 * qTot^2
End Function
